#!/usr/bin/perl
# Web Graffiti Wall CGI
# Copyright (C) 1997 George Lebl.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

use Text::Wrap;

if(@_) {
	local (*in) = @_;
}

local ($1, $loc, $key, $val);

if ($ENV{'REQUEST_METHOD'} eq "GET") {
	$in = $ENV{'QUERY_STRING'};
} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
	for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
		$in .= getc;
	}
}

@in = split(/&/,$in);

foreach $i (0 .. $#in) {
	$in[$i] =~ s/\+/ /g;
	$in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
	$loc = index($in[$i],"=");
	$key = substr($in[$i],0,$loc);
	$val = substr($in[$i],$loc+1);
	$in{$key} .= '\0' if (defined($in{$key}));
	$in{$key} .= $val;
}

print STDOUT "Content-type: text/html\n\n";
print STDOUT "<html><head><title>Post Results</title></head>\n";
print STDOUT "<body><h1>Post Results</h1><p>";

open (WALL,"walldat.html") || 
	die "ERROR: Cannot open wall data file</body></html>\n";

$postnum=0;
while (<WALL>) {
	if(!( $_ =~ /^<A NAME/ )) {
		$wall[$postnum] .= $_;
		if( $_ =~ /^<HR/) {
			$postnum++;
		}
	}
}
$begcount=$postnum-19;
if($begcount < 0) {
	$begcount = 0;
}
close(WALL);	

open (WALL,">walldat.html") || 
	die "ERROR: Cannot open wall data file</body></html>\n";

for ($i=$begcount; $i < $postnum; $i++) {
	print WALL $wall[$i];
}

foreach $key (keys %in) {
	$in{$key} =~ s/\+/ /g;
	$in{$key} =~ s/%(..)/pack("c",hex($1))/ge;
}
 

$in{'body'} =~ s/&/&amp;/g;
$in{'body'} =~ s/>/&gt;/g;
$in{'body'} =~ s/</&lt;/g;
$in{'body'} =~ s/"/&#34;/g;
$in{'body'} =~ s/
//g;
$in{'name'} =~ s/^$/Anonymous/;
$in{'body'} .= "\n";

$Text::Wrap::columns = 76;
$in{'body'} = wrap("","",$in{'body'});

$in{'body'} =~ s/(http:\/\/[a-zA-Z_.\-0-9\/~%]+[a-zA-Z_0-9\/])/<A HREF=\"$1\">$1<\/A>/gm;
$in{'body'} =~ s/([a-zA-Z_.\-0-9]+\@[a-zA-Z_.\-0-9]*[a-zA-Z0-9])/<A HREF=\"mailto:$1\">$1<\/A>/gm;

chomp($in{'body'});

print WALL "\n<A NAME=\"lastpost\"></A>";
print WALL "\n<BR><B>Posted by: <A HREF=\"mailto:" . $in{'email'} . "\">";
print WALL $in{'name'} . "</A>\n";
print WALL "<BR>Posted on: " . localtime(time) . "</B>\n";
print WALL "<P><PRE>" . $in{body} . "</PRE><P>\n<HR NOSHADE>\n";

close(WALL);

#print "<B>Preview:</B><HR>\n";
#print "\n<B>Posted by: <A HREF=\"mailto:" . $in{'email'} . "\">";
#print $in{'name'} . "</A>\n";
#print "<BR>Posted on: " . localtime(time) . "</B>\n";
#print "<P><PRE>" . $in{body} . "</PRE><P>\n";
print "<HR><B><FONT SIZE=\"+1\">Posted OK</FONT></B></body></html>";
